unit MODBUSSERVERLib_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ ModbusServer 1.0 Type Library }
{ Version 1.0 }

{ Conversion log:
  Warning: 'Type' is a reserved word. Parameter 'Type' in IModbusSrv.OpenConnection changed to 'Type_'
 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_MODBUSSERVERLib: TGUID = '{B3DE3CB4-C629-11D1-8FE9-E4CD05C10000}';

const

{ __MIDL___MIDL_itf_ModbusServer_0138_0001 }

  mbErrOk = 0;
  mbErrTimeOut = -2147220991;
  mbErrInvResp = -2147220990;
  mbErrCRC = -2147220989;
  mbErrWrPort = -2147220984;
  mbErrRdPort = -2147220983;
  mbErrNotInit = -2147220982;
  mbErrExceptionCode = -2147188224;
  mbErrOffset = 512;
  mbErrBufferOverflow = -2147219992;
  mbErrSocketError = -2147219991;
  mbErrWriteSockError = -2147219990;
  mbErrReadSockError = -2147219989;
  mbErrSockNotConnected = -2147219988;

{ __MIDL___MIDL_itf_ModbusServer_0138_0002 }

  mbNOPARITY = 0;
  mbODDPARITY = 1;
  mbEVENPARITY = 2;
  mbMARKPARITY = 3;
  mbSPACEPARITY = 4;
  mbONESTOPBIT = 0;
  mbONE5STOPBITS = 1;
  mbTWOSTOPBITS = 2;
  mbFC_NONE = 0;
  mbFC_DTRDSR = 1;
  mbFC_RTSCTS = 2;
  mbFC_XONXOFF = 4;
  mbLOCAL = 1;
  mbREMOTE = 2;
  mbMODE_RTU = 0;
  mbMODE_ASCII = 1;
  mbREAL_NORMAL = 0;
  mbREAL_REVERSE = 1;

const

{ Component class GUIDs }
  Class_ModbusSrv: TGUID = '{B3DE3CC2-C629-11D1-8FE9-E4CD05C10000}';
  Class_CTCPIPServer: TGUID = '{47ADFAE2-D261-11D1-8FE9-6CD504C1BC01}';

type

{ Forward declarations: Interfaces }
  IModbusSrv = interface;
  IModbusSrvDisp = dispinterface;
  ICTCPIPServer = interface;
  ICTCPIPServerDisp = dispinterface;

{ Forward declarations: CoClasses }
  ModbusSrv = IModbusSrv;
  CTCPIPServer = ICTCPIPServer;

{ Forward declarations: Enums }
  __MIDL___MIDL_itf_ModbusServer_0138_0001 = TOleEnum;
  __MIDL___MIDL_itf_ModbusServer_0138_0002 = TOleEnum;

  ErrorConstants = __MIDL___MIDL_itf_ModbusServer_0138_0001;

  GeneralConstants = __MIDL___MIDL_itf_ModbusServer_0138_0002;

{ IModbusSrv Interface }

  IModbusSrv = interface(IDispatch)
    ['{B3DE3CC1-C629-11D1-8FE9-E4CD05C10000}']
    procedure CloseConnection; safecall;
    function Get_ComPort: Smallint; safecall;
    procedure Set_ComPort(Value: Smallint); safecall;
    function Get_BaudRate: Integer; safecall;
    procedure Set_BaudRate(Value: Integer); safecall;
    function Get_Parity: Smallint; safecall;
    procedure Set_Parity(Value: Smallint); safecall;
    function Get_FlowControl: Smallint; safecall;
    procedure Set_FlowControl(Value: Smallint); safecall;
    function Connect: WordBool; safecall;
    function OpenConnection(const Name: WideString; Type_: Smallint): WordBool; safecall;
    function Get_RaiseError: WordBool; safecall;
    procedure Set_RaiseError(Value: WordBool); safecall;
    function PresetSingleRegister(Addr: Smallint; Register: Integer; RegValue, vRealType: OleVariant): Integer; safecall;
    function ForceSingleCoil(Addr: Smallint; Register: Integer; CoilValue: WordBool): Integer; safecall;
    function ReadOutputRegisters(Addr: Smallint; DataStart: Integer; Quantity: Smallint; var vRegValues: OleVariant; vVarType, vRealType: OleVariant): Integer; safecall;
    function ReadInputRegisters(Addr: Smallint; DataStart: Integer; Quantity: Smallint; out vRegValues: OleVariant; vVarType, vRealType: OleVariant): Integer; safecall;
    function ReadOutputStatus(Addr: Smallint; DataStart: Integer; Quantity: Smallint; out vCoilValues: OleVariant): Integer; safecall;
    function ReadInputStatus(Addr: Smallint; DataStart: Integer; Quantity: Smallint; out vCoilValues: OleVariant): Integer; safecall;
    function PresetMultipleRegisters(Addr: Smallint; DataStart: Integer; Quantity: Smallint; vRegValues, vRealType: OleVariant): Integer; safecall;
    function ForceMultipleCoils(Addr: Smallint; DataStart: Integer; Quantity: Smallint; vCoilValues: OleVariant): Integer; safecall;
    function Get_Retries: Smallint; safecall;
    procedure Set_Retries(Value: Smallint); safecall;
    function Get_IsActive: WordBool; safecall;
    function Get_Host: WideString; safecall;
    procedure Set_Host(const Value: WideString); safecall;
    function Get_TcpPort: Integer; safecall;
    procedure Set_TcpPort(Value: Integer); safecall;
    function TxRxMessage(vQuery: OleVariant; QueryLength: Smallint; out vResponse: OleVariant; RespLength: Smallint; out vNumOfBytesRead: OleVariant): Integer; safecall;
    function Get_TcpServer: IDispatch; safecall;
    function CreateTCPServer: IDispatch; safecall;
    function Get_SilentInterval: Integer; safecall;
    procedure Set_SilentInterval(Value: Integer); safecall;
    function Get_TimeOut: Integer; safecall;
    procedure Set_TimeOut(Value: Integer); safecall;
    function Get_StopBits: Smallint; safecall;
    procedure Set_StopBits(Value: Smallint); safecall;
    function Get_TransmissionMode: Smallint; safecall;
    procedure Set_TransmissionMode(Value: Smallint); safecall;
    function Get_ByteSize: Smallint; safecall;
    procedure Set_ByteSize(Value: Smallint); safecall;
    property ComPort: Smallint read Get_ComPort write Set_ComPort;
    property BaudRate: Integer read Get_BaudRate write Set_BaudRate;
    property Parity: Smallint read Get_Parity write Set_Parity;
    property FlowControl: Smallint read Get_FlowControl write Set_FlowControl;
    property RaiseError: WordBool read Get_RaiseError write Set_RaiseError;
    property Retries: Smallint read Get_Retries write Set_Retries;
    property IsActive: WordBool read Get_IsActive;
    property Host: WideString read Get_Host write Set_Host;
    property TcpPort: Integer read Get_TcpPort write Set_TcpPort;
    property TcpServer: IDispatch read Get_TcpServer;
    property SilentInterval: Integer read Get_SilentInterval write Set_SilentInterval;
    property TimeOut: Integer read Get_TimeOut write Set_TimeOut;
    property StopBits: Smallint read Get_StopBits write Set_StopBits;
    property TransmissionMode: Smallint read Get_TransmissionMode write Set_TransmissionMode;
    property ByteSize: Smallint read Get_ByteSize write Set_ByteSize;
  end;

{ DispInterface declaration for Dual Interface IModbusSrv }

  IModbusSrvDisp = dispinterface
    ['{B3DE3CC1-C629-11D1-8FE9-E4CD05C10000}']
    procedure CloseConnection; dispid 1;
    property ComPort: Smallint dispid 2;
    property BaudRate: Integer dispid 3;
    property Parity: Smallint dispid 4;
    property FlowControl: Smallint dispid 6;
    function Connect: WordBool; dispid 7;
    function OpenConnection(const Name: WideString; Type_: Smallint): WordBool; dispid 8;
    property RaiseError: WordBool dispid 9;
    function PresetSingleRegister(Addr: Smallint; Register: Integer; RegValue, vRealType: OleVariant): Integer; dispid 10;
    function ForceSingleCoil(Addr: Smallint; Register: Integer; CoilValue: WordBool): Integer; dispid 11;
    function ReadOutputRegisters(Addr: Smallint; DataStart: Integer; Quantity: Smallint; var vRegValues: OleVariant; vVarType, vRealType: OleVariant): Integer; dispid 12;
    function ReadInputRegisters(Addr: Smallint; DataStart: Integer; Quantity: Smallint; out vRegValues: OleVariant; vVarType, vRealType: OleVariant): Integer; dispid 13;
    function ReadOutputStatus(Addr: Smallint; DataStart: Integer; Quantity: Smallint; out vCoilValues: OleVariant): Integer; dispid 14;
    function ReadInputStatus(Addr: Smallint; DataStart: Integer; Quantity: Smallint; out vCoilValues: OleVariant): Integer; dispid 15;
    function PresetMultipleRegisters(Addr: Smallint; DataStart: Integer; Quantity: Smallint; vRegValues, vRealType: OleVariant): Integer; dispid 16;
    function ForceMultipleCoils(Addr: Smallint; DataStart: Integer; Quantity: Smallint; vCoilValues: OleVariant): Integer; dispid 17;
    property Retries: Smallint dispid 18;
    property IsActive: WordBool readonly dispid 19;
    property Host: WideString dispid 20;
    property TcpPort: Integer dispid 21;
    function TxRxMessage(vQuery: OleVariant; QueryLength: Smallint; out vResponse: OleVariant; RespLength: Smallint; out vNumOfBytesRead: OleVariant): Integer; dispid 22;
    property TcpServer: IDispatch readonly dispid 23;
    function CreateTCPServer: IDispatch; dispid 24;
    property SilentInterval: Integer dispid 25;
    property TimeOut: Integer dispid 26;
    property StopBits: Smallint dispid 27;
    property TransmissionMode: Smallint dispid 28;
    property ByteSize: Smallint dispid 29;
  end;

{ ICTCPIPServer Interface }

  ICTCPIPServer = interface(IDispatch)
    ['{47ADFAE1-D261-11D1-8FE9-6CD504C1BC01}']
    function Get_ServerAddress: WideString; safecall;
    procedure Set_ServerAddress(const Value: WideString); safecall;
    function Get_ServerPort: Integer; safecall;
    procedure Set_ServerPort(Value: Integer); safecall;
    function StartServer: WordBool; safecall;
    function StopServer: WordBool; safecall;
    function Get_ServerActive: WordBool; safecall;
    function GetLocalHostIP: WideString; safecall;
    property ServerAddress: WideString read Get_ServerAddress write Set_ServerAddress;
    property ServerPort: Integer read Get_ServerPort write Set_ServerPort;
    property ServerActive: WordBool read Get_ServerActive;
  end;

{ DispInterface declaration for Dual Interface ICTCPIPServer }

  ICTCPIPServerDisp = dispinterface
    ['{47ADFAE1-D261-11D1-8FE9-6CD504C1BC01}']
    property ServerAddress: WideString dispid 1;
    property ServerPort: Integer dispid 2;
    function StartServer: WordBool; dispid 3;
    function StopServer: WordBool; dispid 4;
    property ServerActive: WordBool readonly dispid 5;
    function GetLocalHostIP: WideString; dispid 6;
  end;

{ ModbusSrv Class }

  CoModbusSrv = class
    class function Create: IModbusSrv;
    class function CreateRemote(const MachineName: string): IModbusSrv;
  end;

{ CTCPIPServer Class }

  CoCTCPIPServer = class
    class function Create: ICTCPIPServer;
    class function CreateRemote(const MachineName: string): ICTCPIPServer;
  end;



implementation

uses ComObj;

class function CoModbusSrv.Create: IModbusSrv;
begin
  Result := CreateComObject(Class_ModbusSrv) as IModbusSrv;
end;

class function CoModbusSrv.CreateRemote(const MachineName: string): IModbusSrv;
begin
  Result := CreateRemoteComObject(MachineName, Class_ModbusSrv) as IModbusSrv;
end;

class function CoCTCPIPServer.Create: ICTCPIPServer;
begin
  Result := CreateComObject(Class_CTCPIPServer) as ICTCPIPServer;
end;

class function CoCTCPIPServer.CreateRemote(const MachineName: string): ICTCPIPServer;
begin
  Result := CreateRemoteComObject(MachineName, Class_CTCPIPServer) as ICTCPIPServer;
end;


end.
